/*
 * submit_command_async.c
 *
 *  Created on: 2 juil. 2015
 *      Author: cresson
 */

#include "drmaa.h"
#include <stdlib.h>     /* exit, EXIT_FAILURE */
#include <stdlib.h>
#include <string.h>

void concat(char *s1, char *s2)
{
    char *result = malloc(strlen(s1)+strlen(s2)+1);//+1 for the zero-terminator
    //in real code you would check for errors in malloc here
    strcpy(result, s1);
    strcat(result, s2);
free(s1);
    s1 = result;
}

int main (int argc, char **argv) {
if (argc<2)
{
printf ("The given command is empty!\n");
return EXIT_FAILURE;
}

   char error[DRMAA_ERROR_STRING_BUFFER];
   int errnum = 0;
   drmaa_job_template_t *jt = NULL;

   errnum = drmaa_init (NULL, error, DRMAA_ERROR_STRING_BUFFER);

   if (errnum != DRMAA_ERRNO_SUCCESS) {
      fprintf (stderr, "Could not initialize the DRMAA library: %s\n", error);
      return EXIT_FAILURE;
   }

   errnum = drmaa_allocate_job_template (&jt, error, DRMAA_ERROR_STRING_BUFFER);

   if (errnum != DRMAA_ERRNO_SUCCESS) {
      fprintf (stderr, "Could not create job template: %s\n", error);
      return EXIT_FAILURE;
   }
   else {

      int i;
      int count = 0;
      for (i=1; i<argc; i++)
      {
        count += strlen(argv[i]); // argument lenght
        count += 1; // space between arguments
      }
      char command[count];
      strcpy(command, argv[1]);
      for (i=2; i<argc; i++)
      {
        strcat(command," ");
        strcat(command,argv[i]);
      }

      errnum = drmaa_set_attribute (jt, DRMAA_REMOTE_COMMAND, command /*"/gpfs-dell/data/work/GEOSUD/drmaa/test/drmaa_operator/bin/./sleeper.sh"*/,
                                    error, DRMAA_ERROR_STRING_BUFFER);

      if (errnum != DRMAA_ERRNO_SUCCESS) {
         fprintf (stderr, "Could not set attribute \"%s\": %s\n",
                  DRMAA_REMOTE_COMMAND, error);
         return EXIT_FAILURE;
      }
      else {
/*

         const char *args[2] = {command, NULL};

         errnum = drmaa_set_vector_attribute (jt, DRMAA_V_ARGV, args, error,
                                              DRMAA_ERROR_STRING_BUFFER);
      }

      if (errnum != DRMAA_ERRNO_SUCCESS) {
         fprintf (stderr, "Could not set attribute \"%s\": %s\n",
                  DRMAA_REMOTE_COMMAND, error);
         return EXIT_FAILURE;
      }
      else {
*/
         char jobid[DRMAA_JOBNAME_BUFFER];

         errnum = drmaa_run_job (jobid, DRMAA_JOBNAME_BUFFER, jt, error,
                                 DRMAA_ERROR_STRING_BUFFER);

         if (errnum != DRMAA_ERRNO_SUCCESS) {
            fprintf (stderr, "Could not submit job: %s\n", error);
            return EXIT_FAILURE;
         }
         else {
            printf ("Your job has been submitted with id %s\n", jobid);
         }
      } /* else */

      errnum = drmaa_delete_job_template (jt, error, DRMAA_ERROR_STRING_BUFFER);

      if (errnum != DRMAA_ERRNO_SUCCESS) {
         fprintf (stderr, "Could not delete job template: %s\n", error);
         return EXIT_FAILURE;
      }
   } /* else */

   errnum = drmaa_exit (error, DRMAA_ERROR_STRING_BUFFER);

   if (errnum != DRMAA_ERRNO_SUCCESS) {
      fprintf (stderr, "Could not shut down the DRMAA library: %s\n", error);
      return EXIT_FAILURE;
   }

   return EXIT_SUCCESS;
}

